Index: uspace/app/tmon/resolve.h
===================================================================
--- uspace/app/tmon/resolve.h	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
+++ uspace/app/tmon/resolve.h	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -0,0 +1,47 @@
+/*
+ * Copyright (c) 2017 Petr Manek
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup tmon
+ * @{
+ */
+/**
+ * @file USB diagnostic device resolving.
+ */
+
+#ifndef TMON_RESOLVE_H_
+#define TMON_RESOLVE_H_
+
+#include <devman.h>
+
+int tmon_resolve_default(devman_handle_t *);
+int tmon_resolve_named(const char *, devman_handle_t *);
+
+#endif /* TMON_RESOLVE_H_ */
+
+/** @}
+ */
Index: uspace/app/tmon/tf.c
===================================================================
--- uspace/app/tmon/tf.c	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
+++ uspace/app/tmon/tf.c	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -0,0 +1,109 @@
+/*
+ * Copyright (c) 2017 Petr Manek
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup tmon
+ * @{
+ */
+/**
+ * @file
+ * Testing framework.
+ */
+
+#include <stdio.h>
+#include <devman.h>
+#include <str_error.h>
+#include <usbdiag_iface.h>
+#include "resolve.h"
+#include "tf.h"
+
+#define NAME "tmon"
+#define MAX_PATH_LENGTH 1024
+
+/** Common command handler for all test commands.
+ * @param[in] argc Number of arguments.
+ * @param[in] argv Argument values. Must point to exactly `argc` strings.
+ *
+ * @return Exit code
+ */
+int tmon_test_main(int argc, char *argv[], const tmon_test_ops_t *ops)
+{
+	// Resolve device function.
+	devman_handle_t fun = -1;
+
+	if (argc >= 2 && *argv[1] != '-') {
+		// Assume that the first argument is device path.
+		if (tmon_resolve_named(argv[1], &fun))
+			return 1;
+	} else {
+		// The first argument is either an option or not present.
+		if (tmon_resolve_default(&fun))
+			return 1;
+	}
+
+	int rc, ec;
+	char path[MAX_PATH_LENGTH];
+	if ((rc = devman_fun_get_path(fun, path, sizeof(path)))) {
+		printf(NAME ": Error resolving path of device with handle "
+		    "%" PRIun ". %s\n", fun, str_error(rc));
+		return 1;
+	}
+
+	printf("Using device: %s\n", path);
+
+	// Read test parameters from options.
+	tmon_test_params_t *params = NULL;
+	if ((rc = ops->read_params(argc, argv, &params))) {
+		printf(NAME ": Reading test parameters failed. %s\n", str_error(rc));
+		return 1;
+	}
+
+	// Run the test body.
+	async_sess_t *sess = usbdiag_connect(fun);
+	if (!sess) {
+		printf(NAME ": Could not connect to the device.\n");
+		return 1;
+	}
+
+	async_exch_t *exch = async_exchange_begin(sess);
+	if (!exch) {
+		printf(NAME ": Could not start exchange with the device.\n");
+		ec = 1;
+		goto err_sess;
+	}
+
+	ec = ops->run(exch, params);
+	async_exchange_end(exch);
+
+err_sess:
+	usbdiag_disconnect(sess);
+	free(params);
+	return ec;
+}
+
+/** @}
+ */
Index: uspace/app/tmon/tf.h
===================================================================
--- uspace/app/tmon/tf.h	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
+++ uspace/app/tmon/tf.h	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -0,0 +1,57 @@
+/*
+ * Copyright (c) 2017 Petr Manek
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup tmon
+ * @{
+ */
+/**
+ * @file Testing framework definitions.
+ */
+
+#ifndef TMON_TF_H_
+#define TMON_TF_H_
+
+#include <async.h>
+
+/** Parameters common for all tests. */
+typedef struct tmon_test_params {
+	/* Nothing here. */
+} tmon_test_params_t;
+
+/** Operations to implement by all tests. */
+typedef struct tmon_test_ops {
+	int (*run)(async_exch_t *, const tmon_test_params_t *);
+	int (*read_params)(int, char **, tmon_test_params_t **);
+} tmon_test_ops_t;
+
+int tmon_test_main(int, char **, const tmon_test_ops_t *);
+
+#endif /* TMON_TF_H_ */
+
+/** @}
+ */
Index: uspace/app/usbinfo/dump.c
===================================================================
--- uspace/app/usbinfo/dump.c	(revision 2752620b090f5bf0ecc3baace21dc1fa5da89d73)
+++ uspace/app/usbinfo/dump.c	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -61,5 +61,6 @@
 		INDENT INDENT INDENT,
 		INDENT INDENT INDENT INDENT,
-		INDENT INDENT INDENT INDENT INDENT
+		INDENT INDENT INDENT INDENT INDENT,
+		INDENT INDENT INDENT INDENT INDENT INDENT,
 	};
 	static size_t indents_count = sizeof(indents)/sizeof(indents[0]);
Index: uspace/app/usbinfo/hid.c
===================================================================
--- uspace/app/usbinfo/hid.c	(revision 2752620b090f5bf0ecc3baace21dc1fa5da89d73)
+++ uspace/app/usbinfo/hid.c	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -141,5 +141,5 @@
 	    raw_report, report_size, &actual_report_size);
 	if (rc != EOK) {
-		usb_log_error("Failed to retrieve HID report descriptor: %s.\n",
+		usb_log_error("Failed to retrieve HID report descriptor: %s.",
 		    str_error(rc));
 		free(raw_report);
@@ -150,5 +150,5 @@
 	rc = usb_hid_parse_report_descriptor(&report, raw_report, report_size);
 	if (rc != EOK) {
-		usb_log_error("Failed to part report descriptor: %s.\n",
+		usb_log_error("Failed to part report descriptor: %s.",
 		    str_error(rc));
 	}
Index: uspace/app/usbinfo/info.c
===================================================================
--- uspace/app/usbinfo/info.c	(revision 2752620b090f5bf0ecc3baace21dc1fa5da89d73)
+++ uspace/app/usbinfo/info.c	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -151,4 +151,10 @@
 }
 
+static void dump_descriptor_tree_brief_superspeed_endpoint_companion(const char *prefix,
+    usb_superspeed_endpoint_companion_descriptor_t *descriptor)
+{
+	printf("%sSuperspeed endpoint companion\n", prefix);
+}
+
 static void dump_descriptor_tree_brief_hid(const char *prefix,
     usb_standard_hid_descriptor_t *descriptor)
@@ -206,4 +212,7 @@
 		    usb_standard_endpoint_descriptor_t,
 		    dump_descriptor_tree_brief_endpoint);
+		_BRANCH(USB_DESCTYPE_SSPEED_EP_COMPANION,
+		    usb_superspeed_endpoint_companion_descriptor_t,
+		    dump_descriptor_tree_brief_superspeed_endpoint_companion);
 		_BRANCH(USB_DESCTYPE_HID,
 		    usb_standard_hid_descriptor_t,
Index: uspace/app/vuhid/hids/bootkbd.c
===================================================================
--- uspace/app/vuhid/hids/bootkbd.c	(revision 2752620b090f5bf0ecc3baace21dc1fa5da89d73)
+++ uspace/app/vuhid/hids/bootkbd.c	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -110,5 +110,5 @@
 #define _GET_LED(index, signature) \
 	(((leds) & (1 << index)) ? (signature) : '-')
-	usb_log_info("%s: LEDs = %c%c%c%c%c\n",
+	usb_log_info("%s: LEDs = %c%c%c%c%c",
 	    iface->name,
 	    _GET_LED(0, '0'), _GET_LED(1, 'A'), _GET_LED(2, 's'),
Index: uspace/app/vuhid/life.c
===================================================================
--- uspace/app/vuhid/life.c	(revision 2752620b090f5bf0ecc3baace21dc1fa5da89d73)
+++ uspace/app/vuhid/life.c	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -45,5 +45,5 @@
 	data->data_in_last_pos = (size_t) -1;
 	async_usleep(1000 * 1000 * 5);
-	usb_log_debug("%s\n", data->msg_born);
+	usb_log_debug("%s", data->msg_born);
 	while (data->data_in_pos < data->data_in_count) {
 		async_usleep(1000 * data->data_in_pos_change_delay);
@@ -51,5 +51,5 @@
 		data->data_in_pos++;
 	}
-	usb_log_debug("%s\n", data->msg_die);
+	usb_log_debug("%s", data->msg_die);
 }
 
Index: uspace/app/vuhid/main.c
===================================================================
--- uspace/app/vuhid/main.c	(revision 2752620b090f5bf0ecc3baace21dc1fa5da89d73)
+++ uspace/app/vuhid/main.c	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -227,5 +227,5 @@
 
 	for (int i = 0; i < (int) hid_dev.descriptors->configuration->extra_count; i++) {
-		usb_log_debug("Found extra descriptor: %s.\n",
+		usb_log_debug("Found extra descriptor: %s.",
 		    usb_debug_str_buffer(
 		        hid_dev.descriptors->configuration->extra[i].data,
Index: uspace/app/vuhid/virthid.h
===================================================================
--- uspace/app/vuhid/virthid.h	(revision 2752620b090f5bf0ecc3baace21dc1fa5da89d73)
+++ uspace/app/vuhid/virthid.h	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -40,5 +40,5 @@
 #include <fibril_synch.h>
 
-#define VUHID_ENDPOINT_MAX USB11_ENDPOINT_MAX
+#define VUHID_ENDPOINT_MAX USB_ENDPOINT_MAX
 #define VUHID_INTERFACE_MAX 8
 
Index: uspace/drv/block/usbmast/bo_trans.c
===================================================================
--- uspace/drv/block/usbmast/bo_trans.c	(revision 2752620b090f5bf0ecc3baace21dc1fa5da89d73)
+++ uspace/drv/block/usbmast/bo_trans.c	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -90,5 +90,5 @@
 	    str_error(rc));
 	if (rc != EOK) {
-		usb_log_error("Bulk out write failed: %s\n", str_error(rc));
+		usb_log_error("Bulk out write failed: %s", str_error(rc));
 		return EIO;
 	}
@@ -154,12 +154,12 @@
 	case cbs_failed:
 		cmd->status = CMDS_FAILED;
-		usb_log_error("CBS Failed.\n");
+		usb_log_error("CBS Failed.");
 		break;
 	case cbs_phase_error:
-		usb_log_error("CBS phase error.\n");
+		usb_log_error("CBS phase error.");
 		rc = EIO;
 		break;
 	default:
-		usb_log_error("CBS other error.\n");
+		usb_log_error("CBS other error.");
 		rc = EIO;
 		break;
@@ -168,5 +168,5 @@
 	const size_t residue = uint32_usb2host(csw.dCSWDataResidue);
 	if (residue > dbuf_size) {
-		usb_log_error("Residue > buffer size (%zu > %zu).\n",
+		usb_log_error("Residue > buffer size (%zu > %zu).",
 		    residue, dbuf_size);
 		return EIO;
Index: uspace/drv/block/usbmast/main.c
===================================================================
--- uspace/drv/block/usbmast/main.c	(revision 2752620b090f5bf0ecc3baace21dc1fa5da89d73)
+++ uspace/drv/block/usbmast/main.c	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -156,5 +156,5 @@
 	    usb_device_get_mapped_ep_desc(dev, &bulk_out_ep);
 	if (!epm_in || !epm_out || !epm_in->present || !epm_out->present) {
-		usb_log_error("Required EPs were not mapped.\n");
+		usb_log_error("Required EPs were not mapped.");
 		return ENOENT;
 	}
@@ -163,5 +163,5 @@
 	mdev = usb_device_data_alloc(dev, sizeof(usbmast_dev_t));
 	if (mdev == NULL) {
-		usb_log_error("Failed allocating softstate.\n");
+		usb_log_error("Failed allocating softstate.");
 		return ENOMEM;
 	}
@@ -169,18 +169,17 @@
 	mdev->usb_dev = dev;
 
-	usb_log_info("Initializing mass storage `%s'.\n",
+	usb_log_info("Initializing mass storage `%s'.",
 	    usb_device_get_name(dev));
-	usb_log_debug("Bulk in endpoint: %d [%zuB].\n",
-	    epm_in->pipe.endpoint_no, epm_in->pipe.max_packet_size);
-	usb_log_debug("Bulk out endpoint: %d [%zuB].\n",
-	    epm_out->pipe.endpoint_no, epm_out->pipe.max_packet_size);
-
-	usb_log_debug("Get LUN count...\n");
+	usb_log_debug("Bulk in endpoint: %d [%zuB].",
+	    epm_in->pipe.desc.endpoint_no, epm_in->pipe.desc.max_transfer_size);
+	usb_log_debug("Bulk out endpoint: %d [%zuB].",
+	    epm_out->pipe.desc.endpoint_no, epm_out->pipe.desc.max_transfer_size);
+
+	usb_log_debug("Get LUN count...");
 	mdev->lun_count = usb_masstor_get_lun_count(mdev);
 	mdev->luns = calloc(mdev->lun_count, sizeof(ddf_fun_t*));
 	if (mdev->luns == NULL) {
-		rc = ENOMEM;
-		usb_log_error("Failed allocating luns table.\n");
-		goto error;
+		usb_log_error("Failed allocating luns table.");
+		return ENOMEM;
 	}
 
@@ -226,5 +225,5 @@
 
 	if (asprintf(&fun_name, "l%u", lun) < 0) {
-		usb_log_error("Out of memory.\n");
+		usb_log_error("Out of memory.");
 		rc = ENOMEM;
 		goto error;
@@ -233,5 +232,5 @@
 	fun = usb_device_ddf_fun_create(mdev->usb_dev, fun_exposed, fun_name);
 	if (fun == NULL) {
-		usb_log_error("Failed to create DDF function %s.\n", fun_name);
+		usb_log_error("Failed to create DDF function %s.", fun_name);
 		rc = ENOMEM;
 		goto error;
@@ -241,5 +240,5 @@
 	mfun = ddf_fun_data_alloc(fun, sizeof(usbmast_fun_t));
 	if (mfun == NULL) {
-		usb_log_error("Failed allocating softstate.\n");
+		usb_log_error("Failed allocating softstate.");
 		rc = ENOMEM;
 		goto error;
@@ -257,9 +256,9 @@
 	ddf_fun_set_conn_handler(fun, usbmast_bd_connection);
 
-	usb_log_debug("Inquire...\n");
+	usb_log_debug("Inquire...");
 	usbmast_inquiry_data_t inquiry;
 	rc = usbmast_inquiry(mfun, &inquiry);
 	if (rc != EOK) {
-		usb_log_warning("Failed to inquire device `%s': %s.\n",
+		usb_log_warning("Failed to inquire device `%s': %s.",
 		    usb_device_get_name(mdev->usb_dev), str_error(rc));
 		rc = EIO;
@@ -281,5 +280,5 @@
 	rc = usbmast_read_capacity(mfun, &nblocks, &block_size);
 	if (rc != EOK) {
-		usb_log_warning("Failed to read capacity, device `%s': %s.\n",
+		usb_log_warning("Failed to read capacity, device `%s': %s.",
 		    usb_device_get_name(mdev->usb_dev), str_error(rc));
 		rc = EIO;
@@ -295,5 +294,5 @@
 	rc = ddf_fun_bind(fun);
 	if (rc != EOK) {
-		usb_log_error("Failed to bind DDF function %s: %s.\n",
+		usb_log_error("Failed to bind DDF function %s: %s.",
 		    fun_name, str_error(rc));
 		goto error;
@@ -390,5 +389,5 @@
 static const usb_driver_ops_t usbmast_driver_ops = {
 	.device_add = usbmast_device_add,
-	.device_rem = usbmast_device_remove,
+	.device_remove = usbmast_device_remove,
 	.device_gone = usbmast_device_gone,
 };
Index: uspace/drv/block/usbmast/scsi_ms.c
===================================================================
--- uspace/drv/block/usbmast/scsi_ms.c	(revision 2752620b090f5bf0ecc3baace21dc1fa5da89d73)
+++ uspace/drv/block/usbmast/scsi_ms.c	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -116,5 +116,5 @@
 		rc = usb_massstor_unit_ready(mfun);
 		if (rc != EOK) {
-			usb_log_error("Inquiry transport failed, device %s: %s.\n",
+			usb_log_error("Inquiry transport failed, device %s: %s.",
 			   usb_device_get_name(mfun->mdev->usb_dev), str_error(rc));
 			return rc;
@@ -123,5 +123,5 @@
 		rc = usb_massstor_cmd(mfun, 0xDEADBEEF, cmd);
 		if (rc != EOK) {
-			usb_log_error("Inquiry transport failed, device %s: %s.\n",
+			usb_log_error("Inquiry transport failed, device %s: %s.",
 			   usb_device_get_name(mfun->mdev->usb_dev), str_error(rc));
 			return rc;
@@ -131,10 +131,10 @@
 			return EOK;
 
-		usb_log_error("SCSI command failed, device %s.\n",
+		usb_log_error("SCSI command failed, device %s.",
 		    usb_device_get_name(mfun->mdev->usb_dev));
 
 		rc = usbmast_request_sense(mfun, &sense_buf, sizeof(sense_buf));
 		if (rc != EOK) {
-			usb_log_error("Failed to read sense data.\n");
+			usb_log_error("Failed to read sense data.");
 			return EIO;
 		}
@@ -182,5 +182,5 @@
 
 	if (rc != EOK) {
-		usb_log_error("Inquiry transport failed, device %s: %s.\n",
+		usb_log_error("Inquiry transport failed, device %s: %s.",
 		   usb_device_get_name(mfun->mdev->usb_dev), str_error(rc));
 		return rc;
@@ -188,5 +188,5 @@
 
 	if (cmd.status != CMDS_GOOD) {
-		usb_log_error("Inquiry command failed, device %s.\n",
+		usb_log_error("Inquiry command failed, device %s.",
 		   usb_device_get_name(mfun->mdev->usb_dev));
 		return EIO;
@@ -194,5 +194,5 @@
 
 	if (cmd.rcvd_size < SCSI_STD_INQUIRY_DATA_MIN_SIZE) {
-		usb_log_error("SCSI Inquiry response too short (%zu).\n",
+		usb_log_error("SCSI Inquiry response too short (%zu).",
 		    cmd.rcvd_size);
 		return EIO;
@@ -250,5 +250,5 @@
 
         if (rc != EOK || cmd.status != CMDS_GOOD) {
-		usb_log_error("Request Sense failed, device %s: %s.\n",
+		usb_log_error("Request Sense failed, device %s: %s.",
 		   usb_device_get_name(mfun->mdev->usb_dev), str_error(rc));
 		return rc;
@@ -292,5 +292,5 @@
 
         if (rc != EOK) {
-		usb_log_error("Read Capacity (10) transport failed, device %s: %s.\n",
+		usb_log_error("Read Capacity (10) transport failed, device %s: %s.",
 		   usb_device_get_name(mfun->mdev->usb_dev), str_error(rc));
 		return rc;
@@ -298,5 +298,5 @@
 
 	if (cmd.status != CMDS_GOOD) {
-		usb_log_error("Read Capacity (10) command failed, device %s.\n",
+		usb_log_error("Read Capacity (10) command failed, device %s.",
 		   usb_device_get_name(mfun->mdev->usb_dev));
 		return EIO;
@@ -304,5 +304,5 @@
 
 	if (cmd.rcvd_size < sizeof(data)) {
-		usb_log_error("SCSI Read Capacity response too short (%zu).\n",
+		usb_log_error("SCSI Read Capacity response too short (%zu).",
 		    cmd.rcvd_size);
 		return EIO;
@@ -349,5 +349,5 @@
 
         if (rc != EOK) {
-		usb_log_error("Read (10) transport failed, device %s: %s.\n",
+		usb_log_error("Read (10) transport failed, device %s: %s.",
 		   usb_device_get_name(mfun->mdev->usb_dev), str_error(rc));
 		return rc;
@@ -355,5 +355,5 @@
 
 	if (cmd.status != CMDS_GOOD) {
-		usb_log_error("Read (10) command failed, device %s.\n",
+		usb_log_error("Read (10) command failed, device %s.",
 		   usb_device_get_name(mfun->mdev->usb_dev));
 		return EIO;
@@ -361,5 +361,5 @@
 
 	if (cmd.rcvd_size < nblocks * mfun->block_size) {
-		usb_log_error("SCSI Read response too short (%zu).\n",
+		usb_log_error("SCSI Read response too short (%zu).",
 		    cmd.rcvd_size);
 		return EIO;
@@ -405,5 +405,5 @@
 
         if (rc != EOK) {
-		usb_log_error("Write (10) transport failed, device %s: %s.\n",
+		usb_log_error("Write (10) transport failed, device %s: %s.",
 		   usb_device_get_name(mfun->mdev->usb_dev), str_error(rc));
 		return rc;
@@ -411,5 +411,5 @@
 
 	if (cmd.status != CMDS_GOOD) {
-		usb_log_error("Write (10) command failed, device %s.\n",
+		usb_log_error("Write (10) command failed, device %s.",
 		   usb_device_get_name(mfun->mdev->usb_dev));
 		return EIO;
@@ -450,5 +450,5 @@
 
         if (rc != EOK) {
-		usb_log_error("Synchronize Cache (10) transport failed, device %s: %s.\n",
+		usb_log_error("Synchronize Cache (10) transport failed, device %s: %s.",
 		   usb_device_get_name(mfun->mdev->usb_dev), str_error(rc));
 		return rc;
@@ -456,5 +456,5 @@
 
 	if (cmd.status != CMDS_GOOD) {
-		usb_log_error("Synchronize Cache (10) command failed, device %s.\n",
+		usb_log_error("Synchronize Cache (10) command failed, device %s.",
 		   usb_device_get_name(mfun->mdev->usb_dev));
 		return EIO;
Index: uspace/drv/bus/usb/ehci/Makefile
===================================================================
--- uspace/drv/bus/usb/ehci/Makefile	(revision 2752620b090f5bf0ecc3baace21dc1fa5da89d73)
+++ uspace/drv/bus/usb/ehci/Makefile	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -35,5 +35,5 @@
 SOURCES = \
 	ehci_batch.c \
-	ehci_endpoint.c \
+	ehci_bus.c \
 	ehci_rh.c \
 	endpoint_list.c \
